#include "./SaveClosePopup.hpp"

SafeClosePopup::~SafeClosePopup()
{
	CloseWindow();
}

void SafeClosePopup::onAttach()
{
	m_WindowOpen = false;
}

int SafeClosePopup::draw()
{
	if (WindowShouldClose())
	{
		if (m_WindowOpen) {
			CloseWindow();
		}
		else {
			OpenWindow();
		}
		onResize();
	}

	if (m_WindowOpen)
	{
		GuiUnlock();
		anchor03 = { .x = m_WndRect.x + (168 * m_WndScalar), .y = m_WndRect.y + (88 * m_WndScalar) };

		m_WindowOpen = !GuiWindowBox(m_WndRect, "#191# Are you sure you want to close this program?");
		{ // Drawing in different colours
			int border_color = GuiGetStyle(DEFAULT, BORDER_COLOR_NORMAL);
			int base_color = GuiGetStyle(DEFAULT, BASE_COLOR_NORMAL);

			GuiSetStyle(DEFAULT, BORDER_COLOR_NORMAL, 0x7192C2FF);
			GuiSetStyle(DEFAULT, BASE_COLOR_NORMAL, 0xBBCDD3FF);

			m_CQB_YesButton = GuiButton({ anchor03.x + (-152 * m_WndScalar), anchor03.y + (32 * m_WndScalar), 120 * m_WndScalar, 24 * m_WndScalar }, "#112#Yes");

			GuiSetStyle(DEFAULT, BORDER_COLOR_NORMAL, border_color);
			GuiSetStyle(DEFAULT, BASE_COLOR_NORMAL, base_color);
		}
		m_CQB_NoButton = GuiButton({ anchor03.x + (24 * m_WndScalar), anchor03.y + (32 * m_WndScalar), 120 * m_WndScalar, 24 * m_WndScalar }, "#113#No");
		GuiLabel({ anchor03.x + (-104 * m_WndScalar), anchor03.y + (-40 * m_WndScalar), 208 * m_WndScalar, 24 * m_WndScalar }, "Are you sure you want to close this?");
		GuiLabel({ anchor03.x + (-56 * m_WndScalar), anchor03.y + (-8 * m_WndScalar), 120 * m_WndScalar, 24 * m_WndScalar }, "Press \"Yes\" to close");
		if (m_CQB_YesButton)
		{
			*m_WndRunning = false;
			return 1;
		}
		if (m_CQB_NoButton) CloseWindow();
	}
	return 0;
}

int SafeClosePopup::rinput(Vector2& mouse_position)
{
	if (IsKeyReleased(KEY_ENTER)) {
		*m_WndRunning = false;
		return 1;
	}
	GuiLock();
	return 0;
}

void SafeClosePopup::onResize()
{
	anchor03 = { static_cast<float>(m_WndWidth) / 2 , static_cast<float>(m_WndHeight) / 2 };
	m_WndRect = { anchor03.x + -168, anchor03.y + -88, 328, 160 };
	scale(m_WndScalar);
}

void SafeClosePopup::OpenWindow()
{
	GuiLock();
	m_WindowOpen = true;
}

void SafeClosePopup::CloseWindow()
{
	m_WindowOpen = false;
	GuiUnlock();
}
